/***************************************************************************
                          matrix.cpp  -  description
                             -------------------
    begin                : Wed Mar 6 2002
    copyright            : (C) 2002 by Jrgen Bhm
    email                : aviduratas@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it.                                                                   *
 *                                                                         *
 ***************************************************************************/

#include "matrix.h"

void cross ( Point a, Point b, Point c, Point & d ) {

 d.x = ( b.y - a.y ) * ( c.z - a.z ) - ( c.y - a.y ) * ( b.z - a.z );

 d.y = ( c.x - a.x ) * ( b.z - a.z ) - ( b.x - a.x ) * ( c.z - a.z );

 d.z = ( b.x - a.x ) * ( c.y - a.y ) - ( c.x - a.x ) * ( b.y - a.y );

};



void crossnorm ( Point a, Point b, Point c, Point & d ) {

Point dd;

cross ( a, b, c, dd );

GLfloat lengthdd = sqrt ( dotprod ( dd, dd ) );

if ( lengthdd > 0 )

	scalmult ( 1/lengthdd, dd );
	
d = dd;

}


GLfloat dotprod ( Point a, Point b ) {

return (a.x * b.x) + ( a.y * b.y ) + (a.z * b.z);

};


void vecminus ( Point a, Point b, Point & c ) {

c.x = a.x - b.x;
c.y = a.y - b.y;
c.z = a.z - b.z;

};

void vecplus ( Point a, Point b, Point & c ) {

c.x = a.x + b.x;
c.y = a.y + b.y;
c.z = a.z + b.z;

};

void scalmult ( GLfloat l, Point & a ) {

a.x = l * a.x;
a.y = l * a.y;
a.z = l * a.z;

};


