/***************************************************************************
                          surfxpview.h  -  description
                             -------------------
    begin                : Die Mr  5 19:59:18 CET 2002
    copyright            : (C) 2002 by Jrgen Bhm
    email                : aviduratas@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it.                                                                    *
 *                                                                         *
 ***************************************************************************/

#ifndef SURFXPVIEW_H
#define SURFXPVIEW_H

// include files for QT
#include <QtWidgets>
#include <QMessageBox>
#include <QOpenGLWidget>

#include <GL/glu.h>

// application specific includes

#include <math.h>
#include <fstream>

#include "matrix.h"


#include "surfxpdoc.h"

/**
 * This class provides an incomplete base for your application view. 
 */

class SurfxpView : public QOpenGLWidget
{
  Q_OBJECT
  public:
    SurfxpView(QWidget *parent=0, SurfxpDoc* doca=0);
    ~SurfxpView();

	protected:

		void initializeGL ();
		
		void resizeGL ( int w, int h );
		
		void paintGL ();
		
		void mouseMoveEvent ( QMouseEvent * e );
		
		void mousePressEvent ( QMouseEvent * e );
		
		void mouseReleaseEvent ( QMouseEvent * e );
		

		
	private:
	
		SurfxpDoc * doc;
		
		int wd, ht;
		
		Point vturn, vold;
		
		GLfloat angle;
		
		int oldx, oldy;
		
		GLfloat rotmatrix[16];
  
  protected slots:
    void slotDocumentChanged();
  
};

#endif
